<?php
/**
 * @copyright © 2007, 2008, 2009 Intrahealth International, Inc.
 * This File is part of I2CE
 *
 * I2CE is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * The page to send feedback about the site.
 * @package I2CE
 * @subpackage Common
 * @access public
 * @author Ally Shaban <ashabani@intrahealth.org>
 * @since v2.0.0
 * @version v2.0.0
 */

/**
 * The page class for displaying the feedback form.
 * @package I2CE
 * @subpackage Common
 * @access public
 */
 
 /**   Data Import Script Customization Manual   **/
 /** by Dr. Juma Lungo <juma.lungo@zalongwa.com> **
 
1.0 To customize this script start with the function "getExpectedHeaders()" 
2.0 This is where you define your "Excel Column Headers"
3.0 The data will go to an array called "mapped_data" and the headers are the array indexes _processRow()
4.0 The scripts fetches data row by row (one row at a time) and it processes inside processRow() function 
5.0 You can call all various functions that are to be processed for a single record 
6.0 e.g createNewPerson() which adds person info's like surname,first name, etc, to makes a person available to the system.
7.0  When the createNewPerson() function completes, you can call then call the setNewPosition() function by passing the object returned when creating the person
**/ 
//charlie .
require_once("import_base.php");
class I2CE_PageImport extends I2CE_Page 
{
    protected $headers;
    protected $mapped_data;
    protected $data;
    protected $user;    
    protected $db;
    protected $row = 1;
    protected $ff; 
    protected $processRows =null;
    protected $dataFile;
    protected $file;
        
    /**
     * Perform the main actions of the page.
     * @global array
     */	
    protected function action() 
    {
        $i2ce_config = I2CE::getConfig()->I2CE;
        parent::action();
        $valid = true;
        $err_msg = "";
        
        if ( $this->isPost() )
        {        	
        move_uploaded_file($_FILES["hrhis"]["tmp_name"],"/var/lib/iHRIS/ihris-manage-malawi/4.1/modules/import/lib/uploads/importfile.xlsx");
        $this->manual_constructor();
        }
    }
    
    public function manual_constructor()
    {
    	$file="/var/lib/iHRIS/ihris-manage-malawi/4.1/modules/import/lib/uploads/importfile.xlsx";
        $this->file = $file;
        $file_ext = strtolower(substr($file, strrpos($file, '.') + 1));
        if ($file_ext == 'csv') {
            //although CSV can be processed by PHPExcel, we keep this separate in case PHPExcel cannot be installed, we can still export the file as a CSV and process it
            $this->dataFile = new CSVDataFile($file);
        } else {
            $this->dataFile = new ExcelDataFile($file);
        }     
        $this->user = new I2CE_User();
        $this->db= MDB2::singleton();
        $this->ff = I2CE_FormFactory::instance();
        $this->mapHeaders();
        $this->initBadFile(); 
      $this->loadCountryLookup();
      $this->designation= I2CE_FormStorage::listFields('job',array('code','id','title'));
      $this->districts= I2CE_FormStorage::listFields('district',array('name','id'));
      $this->department= I2CE_FormStorage::listFields('department',array('id','name'));
      $this->employmentid= I2CE_FormStorage::listFields('person_id',array('id','id_num','parent'));
      $this->facility= I2CE_FormStorage::listFields('facility',array('id','name','parent'));
      $this->salarygrade= I2CE_FormStorage::listFields('salary_grade',array('id','name','parent'));
      $this->run();
      $this->template->addFile("import_success.html");
    }
    
    protected function mapData() 
    {
        $mapped_data = $this->mapData1();                
        return $mapped_data;
    }
    
        public function getCurrentRow() {
        return $this->row;
    }
    
       public function hasDataRow() {
        return $this->dataFile->hasDataRow();
    }
    
        protected $success = 0;

    protected $blank_lines = 0;
    public function run() 
    {
        $this->success = 0;
        while ( $this->hasDataRow()) {
            if ($this->processRow()) {
                $this->success++;
            }
        }
    }
    
    public function getStats() 
    {
        return array('success'=>$this->success,'attempts'=>($this->row -1)); //this may be off by one.
        $row = $processor->getCurrentRow();
    }
    
        public function processRow() 
    {
        if (!$this->dataFile->hasDataRow()) {
            return false;
        }
        $this->data = $this->dataFile->getDataRow();
        if (!is_array($this->data)) {
            $this->blank_lines++;
            return false;
        }
        $is_blank = true;
        foreach ($this->data as $cell) {
            if (is_string($cell) && strlen(trim($cell)) != 0) {
                $is_blank = false;
                $this->blank_lines = 0;
                break;
            }
        }
        if ($is_blank) {
            $this->blank_lines++;
        } 
        $this->row++;
        if ( ! ($this->mapped_data = $this->mapData1())) {
            return false;
        }
        if ( $this->_processRow()) {            
	    $_SESSION["processed"]="yes";   
            return true;
        } else {
            return false;
        }
    }
    
        protected function save($obj,$cleanup = true) 
    {
        if (!$obj instanceof I2CE_Form) {
            return false;
        }
            $obj->save($this->user);    
            $id = $obj->getID();
            if ($cleanup) {
                $obj->cleanup();
            }
            return $id;
        
    }
    
        protected $header_map;
    protected function mapHeaders() {
        $this->headers = $this->dataFile->getHeaders();
        foreach ($this->headers as &$header) {
            $header = strtolower(trim($header));
        }
        unset($header);
        $this->header_map = array();
        $expected_headers = $this->getExpectedHeaders();
        foreach ($expected_headers as $expected_header_ref => $expected_header) {
            if (($header_col = array_search(strtolower($expected_header),$this->headers)) === false) {
                I2CE::raiseMessage("Could not find $expected_header in the following headers:\n\t" . implode(" ", $expected_headers). "\nFull list of found headers is:\n\t" . implode(" ", $this->headers));
                die();
            }
            $this->header_map[$expected_header_ref] = $header_col;
        }
    }
    
    protected function mapData1() 
    {
        $mapped_data = array();
        foreach ($this->header_map as $header_ref=>$header_col) {
            if (!array_key_exists($header_col,$this->data)) {
                $mapped_data[$header_ref] = false;
            } else {
                $mapped_data[$header_ref] = $this->data[$header_col];
            }
        }
        return $mapped_data;
    }
    
protected $bad_headers;
    protected $bad_fp;        
    protected $bad_file_name;
    protected function initBadFile() {
        $info = pathinfo($this->file);
        $bad_fp =false;
        $this->bad_file_name = dirname($this->file) . DIRECTORY_SEPARATOR . basename($this->file,'.'.$info['extension']) . '.bad_' .date('d-m-Y_G:i') .'.csv';        
        $this->bad_headers = $this->headers;
        $this->bad_headers[] = "Row In " . basename($this->file);
        $this->bad_headers[] = "Reasons for failure";
    }



    function addBadRecord($reason) {
        if (!is_resource($this->bad_fp)) {
            $this->bad_fp = fopen($this->bad_file_name,"w");
            if (!is_resource($this->bad_fp)) {
                I2CE::raiseMessage("Could not open $this->bad_file_name for writing.", E_USER_ERROR);
                die();
            }        
            fputcsv($this->bad_fp, $this->bad_headers);
        }
        I2CE::raiseMessage("Skipping processing of row $this->row: $reason");
        $raw_data = $this->data;
        $raw_data[] = $this->row;
        $raw_data[] = $reason;
        fputcsv($this->bad_fp, $raw_data);
    }    
    
        public static function raw2hex($s) {       
        $op = '';
        for($i = 0; $i < strlen($s); $i++){
            $op .= str_pad(dechex(ord($s[$i])),2,"0",STR_PAD_LEFT);
        }
        return $op;
    }

    protected function getDate($date) {
        //first check the date e.g 16/05/2011
        $matches = array();
        if (is_numeric($date) && class_exists('PHPExcel',false)) {
            //in case we are reading it from excel which returns 40777 instead of 22/08/2011 for example
            $date = PHPExcel_Style_NumberFormat::toFormattedString($date, "DD/MM/YYYY");
        }
        if (!preg_match('/^([0-9]+)\\/([0-9]+)\\/([0-9]+)$/',trim($date),$matches)) {
            $this->addBadRecord("Bad date format [$date]");
            return false;
        }
        list($date,$day,$month,$year) = $matches;
        if ($day < 1 || $day > 31 || $month < 1 || $month > 12 || $year < 1900 || $year > 2100) {
            $this->addBadRecord("Invalid date");
            return false;
        }
        return I2CE_Date::getDate($day,$month,$year);
    }

    
    

    protected function getExpectedHeaders() 
    {
        return  array
        (
		'empno'=>'emEmpNo',
		'emprefno'=>'emEmpRefNo1',
		'district'=>'emEmpHomeDistrict',
		'village'=>'emEmpHomeVillage',
		'country'=>'emEmpCurrentNationality',
		'votecode'=>'esVoteCode',
		'programme'=>'Programme',
		'programmecode'=>'esProgrammeCode',
		'subprogrammecode'=>'esSubProgrammeCode',
		'subsubprogrammecode'=>'esSubSubProgrammeCode',
		'section'=>'esSectionCode',
		'salarygrade'=>'esGradeCode',
		'dutystation'=>'emDutyStation',
		'facilitydistrict'=>'emDistrictCode',
		'costcentre'=>'CosCen',
		'costcentrecode'=>'esCosCenCode',
		'depcode'=>'emDeptCode',
		'commonservice'=>'emComSerCode',
		'depname'=>'emDeptName',
		'poscode'=>'emJobNo',		
		'postype'=>'emEmpTermName',
		'jobtitle'=>'Post',
		'jobcode'=>'esPostCode',
		'jobdesc'=>'emEmpJobDescription',
		'payrate'=>'esSpineValue',
		'date_hired'=>'emProbStarts',
		'confirmationtdate'=>'emConfirmDate',
		'prefix'=>'emEmpPrefix',
		'firstname'=>'emEmpFirstName',
		'othername'=>'emEmpInitials',
		'surname'=>'emEmpSurname',
		'maidenname'=>'emEmpMaidenName',
		'maritalstatus'=>'emEmpMaritalStatusCode',
		'dateofbirth'=>'emEmpDOB',		
		'no_child'=>'emChildDependantCount',
		'no_dep'=>'emOtherDependantCount',
		'sex'=>'emEmpSex',
		'disability'=>'emDisabilityDesc',
		'address'=>'emEmpResAddress',
		'nextofkinfirstname'=>'emNextKinFirstName',
		'nextofkinsurname'=>'emNextKinSurname',
		'nextofkinaddress'=>'emNextKinResAddress',
		'nextofkinrelationship'=>'emRelationship'		       
          );
    }

       protected static $required_cols_by_transaction = array(
        'NE'=>array('firstname','surname')
        );

    protected static $infinium_termination_map = array(
        'DISMI'=>'pos_change_reason|3', //dismisal
        'DEATH'=>'pos_change_reason|1' //death
        // 'CONTE'=>'', //terminaion of contract
        // 'COMRE'=>'', //Compulory retirement
        // 'VOLRE'=>'', //volunary retirement
        // 'EXTTR'=>'', //transfer to another ministry
        // 'PURGE'=>'', //code to purge employees  --- SKIP!
        // 'ENDCO'=>'' //end of contract
        );
    protected static $infinium_stat_code_map = array(
        'TEMPF'=>'position_type|8',//Temp full time -- double check
        'PERM'=>'position_type|1',//Permanent and penshionable
        'FTCON'=>'position_type|2',//fixed term contract --douvle check
        'PROB'=>'position_type|6' //probabionary
        //nothing for acting.
        );


    protected $effective_date;
    protected function _processRow() 
    {
        if (!$this->verifyData()) 
        {
            return false;
        }
        
        # Check to see if an employee exist in the database.
        foreach ($this->employmentid as $id=>&$datas)
        {
                if($datas["id_num"]==$this->mapped_data['empno'])
                {
        	        $this->empl_status="existing_employee";
       		        $this->update_employee_info($datas["parent"]);
                        break;
                }
        }     
        $success = false;
        //if(isset($this->empl_status))
	if($this->empl_status!="existing_employee")
	{   
	   if (!$personObj = $this->createNewPerson()) 
		{
		    break;
	   }                     
		    $success = $this->setNewPosition($personObj);            
		    $personObj->cleanup();
		return $success;
	   }
	   else
	   $this->empl_status="";
	   }


    protected $existing_codes;
    protected function loadCountryLookup() {
        $this->existing_codes= I2CE_FormStorage::listFields('country',array('alpha_two'));
        foreach ($this->existing_codes as $id=>&$data) {
            $data = $data['alpha_two'];
        }
        unset($data);
    }



    function verifyData()
    {
        
        $missing_cols = array();
        foreach (self::$required_cols_by_transaction["NE"] as $required_col) {
            if ($this->mapped_data[$required_col] === false || (is_string($this->mapped_data[$required_col]) && strlen($this->mapped_data[$required_col]) == 0)) {
                $missing_cols[] = $required_col;
            }
        }
        if (count($missing_cols) > 0) {
            $this->addBadRecord("Missing required columns " . implode(" ",$missing_cols));
		$codearr=explode("-",$this->mapped_data["empno"]);
		if(count($codearr)>1)
		{
		$_SESSION["depcode"]=trim($codearr[0]);
		}    
            return false;
        }
        return true;
    }
/*
function addDistrict() 
{
    $domicile=trim($this->mapped_data['district']); 
    foreach($this->districts as $id=>&$data) 
    {
       if($data['name'] == $data || $row['url'] == $data) return $row;
    }
    return NULL;
}
*/
protected function loadDistricts() 
{
	$domicile=trim($this->mapped_data['district']);    
        foreach ($this->districts as $id=>&$data) 
        {
            return $data["id"];
            $founddis=$data["name"];
        exit;
            $domarray=explode(" ",$domicile);
            $districtarray=explode(" ",$data["name"]);
            if (count($domarray)==1 && $domicile==$data["name"])
            {
            return $data["id"];
            break;
            }
            elseif (count($domarray)>1)
            {
            if ($domarray[0]==$domicile)
            {
            return $data["id"];
            break;
            }   
            elseif ($domarray[1]=="Urban" and ($districtarray[1]=="Municipal" or $districtarray[1]=="Urban") and $domarray[0]==$districtarray[0])
            {
            return $data["id"];
            break;
            }    
             
            elseif($domarray[1]=="Rural" and ($districtarray[1]=="District" or $districtarray[1]=="Rural") and $domarray[0]==$districtarray[0])
            {
            return $data["id"];
            break;
            }                                  
            }
            
            else if(count($domarray)==2 and count($districtarray)==1 and $domarray[0]==$districtarray[0])
            {
            return $data["id"];
            break;
            }
            else
            continue;                        
        }        
}
    
protected function load_designation($from)
    {
    $jobcode=$this->mapped_data["jobcode"];
    $jobcodedescr=$this->mapped_data["jobtitle"];    
    
    foreach ($this->designation as $id=>&$data) 
        {
        if (trim($jobcode)==trim($data['code']))
        {      
		if($from=='designation')  
		return $data['title'];
		else
		return $data['id'];
		break;
	}
        else if($jobcodedescr==$data['title'])
        {        
         if($from=='designation')  
        return $data['title'];
        else
        return $data['id'];
        break;
        }
        }
}
    
    protected function load_department()
    {
    $depcode=$this->mapped_data["depcode"];   
    
    foreach ($this->department as $id=>$data) 
        {   
        if (trim($depcode)==trim($data['depname']))
        {    
        return $data['id'];
        break;
        }
        }
    }
    
    //protected function loadJob()
   // {

    //}
    
  //  protected function loadFacility()
  //  {

    //}
    
   // protected function loadSalarygrade()
    //{

    //}
/*
    protected function loadVillages()
    {
    $villagecode=$this->mapped_data["village"];   
    
    foreach ($this->villages as $id=>$data) 
        {   
        if (trim($villagecode)==trim($data['village']))
        {    
        return $data['title'];
        break;
        }
        }
     }
*/     

      function convert_date($from)
      {
      		#converting microsoft access date
      		if($from=="birth")
      		   {
      		      $birthdate=$this->mapped_data['dateofbirth'];      
        	      $date = new DateTime('1899-12-30');
	              $date->modify('+'.$birthdate.'days');
	              $birthdate=$date->format('Y-m-d');
	              if ($birthdate=='1899-12-31')
	              	{
	              	   $birthdate=" ";
	              	}
	              return $birthdate;
	           }
	         elseif ($from=="hired")
	         { 
        	      $hireddate=$this->mapped_data['date_hired'];      
        	      $date = new DateTime('1899-12-30');
	              $date->modify('+'.$hireddate.'days');
	              $hireddate=$date->format('Y-m-d');
	              if ($hireddate=='1899-12-31')
	              	{
	              	   $hireddate=" ";
	              	}	              	
	              return $hireddate;
    		 }
    		 elseif ($from=="conf")
	         { 
        	      $confdate=$this->mapped_data['confirmationtdate'];      
        	      $date = new DateTime('1899-12-30');
	              $date->modify('+'.$confdate.'days');
	              $confdate=$date->format('Y-m-d');
	              if ($confdate=='1899-12-31')
	              	{
	              	   $confdate=" ";
	              	}
	              return $confdate;
    		 }
      		
      		#convert other dates format
      		if($from=="hired" or $from=="conf")
      		{
		        if($from=="conf")
		                $newdate=explode("-",$this->mapped_data['confirmationtdate']);
		        else if($from=="hired")
              		        $newdate=explode(" ",$this->mapped_data['date_hired']); 	
		        if($newdate[2] >12)       
		                $datehired="19".$newdate[2]."-".$newdate[1]."-".$newdate[0];
		        else if($newdate[2] <=12)       
		                $datehired="20".$newdate[2]."-".$newdate[1]."-".$newdate[0];
		                $datehired_timestamp = strtotime($datehired);
		                $datehired = date('Y-m-d', $datehired_timestamp);
		        return $datehired;
      		}
      		
      		else if($from=="end" or $from=="birth")
      		{
              		$newdate=explode("-",$this->mapped_data['dateofbirth']);
		        if($from=="birth")
		        {
		                $datebirth="19".$newdate[2]."-".$newdate[1]."-".$newdate[0];
		                $datebirth_timestamp = strtotime($datebirth);								 
		                $datebirth = date('Y-m-d h:m:s', $datebirth_timestamp);	
		           return $datebirth;
		        }	
              		        $newdate[2]="19".$newdate[2]+60;
              	  	        $dateretire=$newdate[2]."-".$newdate[1]."-".$newdate[0]; 
		                $dateretire_timestamp = strtotime($dateretire);								 
		                $dateretire = date('Y-m-d h:m:s', $dateretire_timestamp);		    
		        return $dateretire;   
      		}	
      }

      function get_marital_id($marital)
      {
	if($marital=="Married")
	return 2;
	else if($marital=="Single")
	return 1;
	else if($marital=="Divorced")
	return 3;
	else if($marital=="Widow")
	return 4;
	else
	return 5;
      }	

      function get_disability_id($disability)
      {
	if($disability=="Deaf")
	return 1;
	else if($disability=="Physical")
	return 2;
	else if($disability=="Vision")
	return 3;
	else if($disability=="Skin")
	return 4;
	else
	return 5;
      }	
    
function create_person_obj($person)
{
        $personObj = $this->ff->createForm($person);
        if (!$personObj instanceof iHRIS_Person) 
        {
            return false;
        }
        $personObj->populate();
        return $personObj;	
}

function create_person_pos_obj($personObj)
{	     
	     $where = array(
                'operator'=>'FIELD_LIMIT',
                'field'=>'end_date',
                'style'=>'null'
                       );
                       
	     $per_pos_id = I2CE_FormStorage::search('person_position', $personObj->getNameId(),$where,'-start_date',1);
        if (!$per_pos_id) {
            return false;
        }                
        $persPosObj = I2CE_FormFactory::instance()->createContainer('person_position'.'|'.$per_pos_id);
        if (!$persPosObj instanceof iHRIS_PersonPosition) {
            return false;
        }
        $persPosObj->populate();
        return $persPosObj;	
}
    
function update_employee_info($person)
{

	$personObj=$this->create_person_obj($person);
	$existingPersonPosObj = $this->create_person_pos_obj($personObj);
	$existingPosObj = $this->ff->createContainer($existingPersonPosObj->position);
	$existingPosObj->populate();
	$salary=number_format($this->mapped_data["payrate"]); 
	$existingPosObj->getField('proposed_salary')->setFromPost('currency|1='.$salary);
	$this->save($existingPosObj);
	
}
    
function createNewPerson() {
    	//for a New Employee, create the Person form
        # Create new form called Person
        $personObj = $this->ff->createContainer('person');
	# Data values for the Position form      
	$fname=ucwords(strtolower($this->mapped_data['firstname']));
	$surname=ucwords(strtolower($this->mapped_data['surname']));	
	$othername=ucwords(strtolower($this->mapped_data['othername']));
	$maidenname=ucwords(strtolower($this->mapped_data['maidenname']));	
	//$appointmentdate=ucwords(strtolower($this->mapped_data['date_hired']));
	# Enter data values for form Person      
        $personObj->firstname = trim($fname);
        $personObj->surname = trim($surname);
        $personObj->othername = trim($othername);
        $personObj->maidenname = trim($maidenname);
        $personObj->getField('datefirstappointment')->setFromPost($this->convert_date("hired"));
	# Adding Prefix
        if($this->mapped_data["prefix"]=="MISS")
		$prefixid=4;
	elseif($this->mapped_data["prefix"]=="MR")
		$prefixid=1;
	elseif($this->mapped_data["prefix"]=="MRS")
		$prefixid=2;
	else        
	{
         }
        $personObj->getField('nametitle')->setFromPost('nametitle|'.$prefixid);
	
        # Adding Nationality 
        if (($country_id = array_search('MW',$this->existing_codes)) !== false) 
        {        
            $personObj->nationality = array('country',$country_id);
        }      
        
        #Adding District of Origin
        $domid=$this->loadDistricts();
        $personObj->getField('residence')->setFromPost('district|'.$domid);
	$personID = $this->save($personObj,false);
	$parent_id='person|'.$personID;
	$_SESSION["parent_id"]=$parent_id;
	
	#Adding Confirmation Date
	$conf=$this->mapped_data['confirmationtdate'];
	$birth=$this->mapped_data['dateofbirth'];
	$confObj = $this->ff->createContainer('confirmationtoservice');
	$confObj->getField('parent')->setValue($parent_id);
	$confObj->getField('confirmationdate')->setFromPost($this->convert_date("conf"));
	$this->save($confObj);

	#Adding Demographic info
	$demObj = $this->ff->createContainer('demographic');
	# Data value 
	#format sex
	if($this->mapped_data["sex"]=="Female")
		$sex='F';
	else
	        $sex='M';
	$children=$this->mapped_data["no_child"];
	$dependents=$this->mapped_data["no_dep"];	
	$demObj->getField('parent')->setValue($parent_id);	        
	$demObj->getField('birth_date')->setFromPost($this->convert_date("birth"));	
	$demObj->gender=array("gender",$sex);
	$demObj->marital_status=array("marital_status",$this->get_marital_id($this->mapped_data["maritalstatus"]));
	$demObj->disability=array("disability",$this->get_disability_id($this->mapped_data["disability"]));	
	$demObj->dependents=$dependents;	
	$this->save($demObj);

        //Adding Employment Identification
        $empno=$this->mapped_data['empno'];
        $idtype='id_type|1'; 
	$idObj = $this->ff->createContainer('person_id');
	$idObj->getField('parent')->setFromPost($parent_id);
	$idObj->getField('id_type')->setFromPost($idtype);   
        $idObj->getField('id_num')->setValue($empno);
        $this->save($idObj);
        
        return $personObj;
    }   

    protected function searchForFacility() {
	        $name = strtolower(trim($this->mapped_data['dutystation']));
	        $where = array(
			        'operator'=>'FIELD_LIMIT',
		             'field'=>'name',
		             'style'=>'lowerequals',
		             'data'=>array(
		             		'value'=>$name
		             	)
		        );
            $matches = I2CE_FormStorage::search('facility',false,$where);
                 //mathches is an array of id's without the "facility|" 
            if (count($matches) == 0) {
                //nothing was found
               return false;
            }
            //possibly more than one match was found (in case a facility name was duplicated).  This is not 
            //good, but not sure if we should fail or just return the first one.   this code below returns the first one.
            return "facility|" . current($matches);
    }
    
   protected function searchForJob() {
	        $name = strtolower(trim($this->mapped_data['jobcode']));
	        $where = array(
			        'operator'=>'FIELD_LIMIT',
		             'field'=>'name',
		             'style'=>'lowerequals',
		             'data'=>array(
		             		'value'=>$name
		             	)
		        );
            $matches = I2CE_FormStorage::search('job',false,$where);
                 //mathches is an array of id's without the "facility|" 
            if (count($matches) == 0) {
                //nothing was found
               return false;
            }
            //possibly more than one match was found (in case a facility name was duplicated).  This is not 
            //good, but not sure if we should fail or just return the first one.   this code below returns the first one.
            return "job|" . current($matches);
    }
    
    protected function searchForSalarygrade() {
	        $name = strtolower(trim($this->mapped_data['salarygrade']));
	        $where = array(
			        'operator'=>'FIELD_LIMIT',
		             'field'=>'name',
		             'style'=>'lowerequals',
		             'data'=>array(
		             		'value'=>$name
		             	)
		        );
            $matches = I2CE_FormStorage::search('salary_grade',false,$where);
                 //mathches is an array of id's without the "facility|" 
            if (count($matches) == 0) {
                //nothing was found
               return false;
            }
            //possibly more than one match was found (in case a facility name was duplicated).  This is not 
            //good, but not sure if we should fail or just return the first one.   this code below returns the first one.
            return "salarygrade|" . current($matches);
    }
    
    function setNewPosition($personObj) 
    {
        # Save your Person id
	$parent_id=$_SESSION["parent_id"];
	$facid = $this->searchForFacility();
        if (!$facid) {
		# Create new forms called Facility
		$newFacObj = $this->ff->createContainer('facility');
		# Data values for the Facility form
		$facilityname = $this->mapped_data['dutystation'];
		$location = $this->ff->createContainer('facilitydistrict');
		# Enter the values for Job form
		//$newFacObj->getField('code')->setValue('');
		$newFacObj->getField('name')->setValue($facilityname);
		$newFacObj->getField('facility_type')->setFromPost('facility_type|1');
		//querying the facility here //
		$newFacId = $this->save($newFacObj);
		$facid='facility|'.$newFacId;
        }

	$salarygradeid = $this->searchForSalarygrade();
        if (!$salarygradeid) 
        {
		# Create new form called Salary_Grade
		$newSgObj = $this->ff->createContainer('salary_grade');
		# Data values for the Salary_Grade form 
		$salarygrade = $this->mapped_data['salarygrade'];
		# Enter the values for Job for
		/** check if grade not exist **/	
		$newSgObj->getField('name')->setValue($salarygrade);
		//query the id of this salary grade //
		$newSgId = $this->save($newSgObj);
		$salarygradeid='salary_grade|'.$newSgId;
        }
	
	    
	$jobid = $this->searchForJob();
        if (!$jobid) {
                # Create new forms called Job
		$newJobObj = $this->ff->createContainer('job');
		# Data values for the Job form
		$post=$this->mapped_data['jobtitle'];
		$jobdesc=$this->mapped_data['jobdesc'];
		$postarray=explode(" ",$post);  
		$jobcode= $postarray[0];
		$jobtitle= $postarray[2].' '.$postarray[3].' '.$postarray[4]; 
		$commonserviceid = $this->mapped_data['commonservice'];
		$depcode = $this->mapped_data['depcode'];
		$coscencode = $this->mapped_data['costcentrecode'];
		/** get the id of the salary grade, then enter it**/
		$salarygradeid = $this->mapped_data['salarygrade'];
		# Enter the values for Job form
		$newJobObj->getField('code')->setValue($jobcode);
		$newJobObj->getField('title')->setValue($jobtitle);
		$newJobObj->getField('description')->setValue($jobdesc);
		$newJobObj->getField('salary_grade')->setFromPost($salarygradeid);
		$newJobObj->getField('commonservice')->setFromPost($commonserviceid);
		$newJobObj->getField('department')->setFromPost($depcode);
		$newJobObj->getField('votecode')->setFromPost($coscencode);
		//querying the job id //
		$newJobId = $this->save($newJobObj);
		$jobid='job|'.$newJobId;
         }
	        
        # Create new forms called Position
        $newPosObj = $this->ff->createContainer('position');
	# Data values for the Position form
	$posjobid=$jobid;
	$posfac=$facid;

	$salary=number_format($this->mapped_data["payrate"]);
	$poscode=$this->mapped_data["poscode"];	
	$postype=$this->mapped_data["postype"];
	$posname=$jobtitle;
	# Enter the values for Position form
	$newPosObj->getField('code')->setValue($poscode);
	$newPosObj->getField('title')->setValue($posname);
	$newPosObj->getField('description')->setValue($jobdesc);
        $newPosObj->getField('facility')->setFromPost($posfac);
        $newPosObj->getField('job')->setFromPost($posjobid);
        $newPosObj->getField('pos_type')->setFromPost($postype);
        $newPosObj->getField('proposed_salary')->setValue('currency|1='.$salary);
        //$newPosObj->description = $this->load_designation('jobdesc');
        //$newPosObj->pos_type= array('position_type','1');        
        $newPosObj->department= array('department',$this->load_department()); 
        //$newPosObj->job = array('job',$this->load_designation('jobtitle'));
        $newPosObj->getField('posted_date')->setFromPost(date("Y-m-d H:i:s"));       
        $newPosObj->getField('proposed_hiring_date')->setFromPost($this->convert_date("hired"));
        //$newPosObj->getField('proposed_end_date')->setFromPost($this->convert_date("end"));
	//$newPosObj->getField('proposed_salary')->setFromPost('currency|1='.$salary);
        $newPosObj->getField('source')->setFromPost('salary_source|1');
        $newPosObj->status = array('position_status','closed');
        $newPosId = $this->save($newPosObj);
        $posid='position|'.$newPosId;
        
        # Create new form called Person_Position
        $newPersonPosObj = $this->ff->createContainer('person_position');
        # # Enter the values for Person_position        
        $newPersonPosObj->getField('start_date')->setFromPost($this->convert_date('hired'));
        $newPersonPosObj->position =array('position',$newPosId);        
        $newPersonPosObj->getField('parent')->setValue($parent_id);
        $newPersonPosId = $this->save($newPersonPosObj);   
        
        # Create new form called Salary
        $newSalaryObj = $this->ff->createContainer('salary');
 	# Enter the values for Salary for
	$newSalaryObj->getField('salary')->setFromPost('currency|1='.$salary);
	$newSalaryObj->getField('start_date')->setFromPost($hired);    
	$newSalaryObj->getField('parent')->setValue('person_position|'.$newPersonPosId);
	$newSalaryId = $this->save($newSalaryObj);
        return true;
    }

}

# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
